<template>
  <div>
    <div v-if="!showForm">
      <rui-actions v-if="map.notes" top>
        <rui-button variant="creative" @click="showForm = true">{{ $t('generic.edit') }}</rui-button>
      </rui-actions>

      <gp-markdown-renderer v-if="map.notes" :content="map.notes" class="_container" />
      <rui-empty v-else role="button" icon-size="3" :content="$t('js.map.note.empty')">
        <template #actions>
          <rui-button variant="creative" :caption="$t('generic.edit')" @click="showForm = true" />
        </template>
      </rui-empty>

      <rui-actions bottom>
        <rui-button @click="$emit('done')">{{ $t('generic.ok') }}</rui-button>
      </rui-actions>
    </div>
    <rui-form v-else
              :errors="errors"
              model="map"
              :loading="loading"
              @cancel="showForm = false"
              @submit.prevent="save">
      <rui-field :help="$t('js.garden.note_form.markdown_help')">
        <textarea id="map_notes" v-model="inputs.notes" name="map_notes" class="-large -markdown" />
      </rui-field>
    </rui-form>
  </div>
</template>

<script>
import RuiActions from '@experiments-labs/rise_ui/src/components/Actions/Actions.vue'
import RuiButton from '@experiments-labs/rise_ui/src/components/Button/Button.vue'
import RuiEmpty from '@experiments-labs/rise_ui/src/components/DataDisplay/Empty/Empty.vue'
import RuiField from '@experiments-labs/rise_ui/src/components/Form/Field.vue'
import RuiForm from '@experiments-labs/rise_ui/src/components/Form/Form.vue'

import Map from '../../../../classes/models/Map'
import GpMarkdownRenderer from '../../../../common/DataDisplay/MarkdownRenderer/MarkdownRenderer.vue'

export default {
  name: 'GpaMapNoteForm',
  emits: [
    'done',
  ],
  components: { RuiField, RuiForm, RuiEmpty, RuiButton, RuiActions, GpMarkdownRenderer },
  props: {
    map: { required: true, type: Map },
  },
  data () {
    return {
      inputs: { notes: this.$props.map.notes },
      showForm: false,
      loading: false,
      errors: null,
    }
  },
  methods: {
    save () {
      this.loading = true
      this.$store.dispatch('updateMap', { id: this.map.id, notes: this.inputs.notes })
        .then(() => { this.showForm = false })
        .catch(() => { this.errors = true })
        .then(() => { this.loading = false })
    },
  },
  watch: {
    map (newValue) {
      this.inputs.notes = newValue.notes || ''
    },
  },
}
</script>
